## ectrans 1.1.0

=== tests/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

### trans_test_install

if( HAVE_TESTS )

  find_package( MPI )
  configure_file( test-install.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-install.sh @ONLY )

  unset( _test_args )
  if( CMAKE_TOOLCHAIN_FILE )
    list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
  endif()
  foreach( lang C CXX Fortran )
    if( CMAKE_${lang}_COMPILER )
      list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
    endif()
  endforeach()
  if( NOT HAVE_DOUBLE_PRECISION )
    list( APPEND _test_args "-DCOMPONENTS=single" )
  endif() 

  add_test( NAME ectrans_test_install
            COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-install.sh ${_test_args} )
endif()


if( HAVE_DOUBLE_PRECISION )
  set( trans trans_dp )
else()
  set( trans trans_sp )
endif()

ecbuild_add_test(TARGET ectrans_test_adjoint
  SOURCES trans/test_adjoint.F90
  LIBS ${trans}
  LINKER_LANGUAGE Fortran
)
if( TEST ectrans_test_adjoint AND HAVE_OMP )
  target_link_libraries( ectrans_test_adjoint OpenMP::OpenMP_Fortran )
endif()

set( ntasks 0 )
set( nthreads 1 )
if( HAVE_MPI )
  list( APPEND ntasks 1 2 )
endif()
if( HAVE_OMP )
  list( APPEND nthreads 4 8 )
endif()

foreach( prec dp sp )
  foreach( mpi ${ntasks} )
    foreach( omp ${nthreads} )
        set( t 47 )
        set( grid O48 )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld0
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 0 -v --meminfo
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --meminfo
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_scders
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --scders
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_vordiv
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_vordiv_uvders
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --uvders
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_flt
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --flt
            MPI ${mpi}
            OMP ${omp}
        )
        ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_nproma16
            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --nproma 16
            MPI ${mpi}
            OMP ${omp}
        )
    endforeach()
  endforeach()
endforeach()


if( HAVE_TRANSI )

  check_include_files( malloc.h       EC_HAVE_MALLOC_H      )
  ecbuild_debug_var( EC_HAVE_MALLOC_H )


  if( EC_HAVE_MALLOC_H AND NOT CMAKE_Fortran_COMPILER_ID MATCHES "Cray" )
    list( APPEND  TEST_DEFINITIONS
      TRANSI_HAVE_MEMORY
    )
  else()
    ecbuild_warn( "ectrans tests checking memory leaks are disabled as malloc.h was not found" )
  endif()

  ecbuild_add_library( TARGET ectrans_test
    SOURCES     transi/transi_test.h transi/transi_test.c
    PUBLIC_LIBS transi_dp
    NOINSTALL
  )
  target_compile_definitions( ectrans_test PUBLIC ${TEST_DEFINITIONS} )

  ecbuild_add_test( TARGET ectrans_test_transi_program
    SOURCES   transi/transi_test_program.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_timings
    SOURCES   transi/transi_test_timings.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_lonlat
    SOURCES   transi/transi_test_lonlat.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_io
    SOURCES   transi/transi_test_io.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_memory
    SOURCES   transi/transi_test_memory.c
    LIBS      ectrans_test
    CONDITION EC_HAVE_MALLOC_H
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_memory_lonlat
    SOURCES   transi/transi_test_memory_lonlat.c
    LIBS      ectrans_test
    CONDITION EC_HAVE_MALLOC_H
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_vordiv_to_UV
    SOURCES   transi/transi_test_vordiv_to_UV.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_dirtrans_adjoint
    SOURCES   transi/transi_test_dirtrans_adjoint.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_invtrans_adjoint
    SOURCES   transi/transi_test_invtrans_adjoint.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

  ecbuild_add_test( TARGET ectrans_test_transi_lonlat_diff_incr
    SOURCES   transi/transi_test_lonlat_diff_incr.c
    LIBS      ectrans_test
    ENVIRONMENT TRANS_USE_MPI=0 )

endif()

=== src/trans/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

## Apply workarounds for some known compilers

if(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  if( CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 8.7 )

    # Fix for IFS "CONGRAD: SPTSV/DPTSV returned non-zero info with crayftn 8.7.7 (cdt/18.12)
    ectrans_add_compile_options(
        SOURCES internal/ftinv_ctlad_mod.F90
        FLAGS   "-O0,fp1,omp")

  endif()
endif()

## Assemble sources

ecbuild_list_add_pattern( LIST trans_src
                          GLOB
                                sharedmem/*
                                algor/*
                                internal/*
                                external/*
                          QUIET
                        )

if( NOT HAVE_FFTW )
  ecbuild_list_exclude_pattern( LIST trans_src REGEX tpm_fftw.F90 )
endif()

set( HAVE_dp ${HAVE_DOUBLE_PRECISION} )
set( HAVE_sp ${HAVE_SINGLE_PRECISION} )

foreach( prec sp dp )
  if( HAVE_${prec} )

    ecbuild_add_library(
      TARGET           trans_${prec}
      LINKER_LANGUAGE  Fortran
      SOURCES          ${trans_src}
      PUBLIC_INCLUDES  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
                       $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/ectrans>
                       $<INSTALL_INTERFACE:include/ectrans>
                       $<INSTALL_INTERFACE:include>
      PUBLIC_LIBS      fiat parkind_${prec}
    )
    ectrans_target_fortran_module_directory(
      TARGET            trans_${prec}
      MODULE_DIRECTORY  ${CMAKE_BINARY_DIR}/module/trans_${prec}
      INSTALL_DIRECTORY module/trans_${prec}
    )
    target_link_libraries( trans_${prec} PUBLIC fiat parkind_${prec} )
    if( HAVE_FFTW )
      set( FFTW_LINK PRIVATE )
      if( LAPACK_${prec} MATCHES "mkl" AND NOT FFTW_LIBRARIES MATCHES "mkl" )
          ecbuild_warn( "Danger: Both MKL and FFTW are linked in trans_${prec}. "
                        "No guarantees on link order can be made for the final executable.")
          set( FFTW_LINK PUBLIC ) # Attempt anyway to give FFTW precedence
      endif()
      target_link_libraries( trans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )
      target_include_directories( trans_${prec} PRIVATE ${FFTW_INCLUDE_DIRS} )
      target_compile_definitions( trans_${prec} PRIVATE WITH_FFTW )
    endif()
    target_link_libraries( trans_${prec} ${LAPACK_LINK} ${LAPACK_${prec}} )
    if( HAVE_OMP )
      target_link_libraries( trans_${prec} PRIVATE OpenMP::OpenMP_Fortran )
    endif()

  endif()
endforeach()

## Install trans interface

file( GLOB trans_interface include/ectrans/* )
install(
  FILES        ${trans_interface}
  DESTINATION  include/ectrans
)

=== debian/changelog ===
ectrans (1.1.0-4) unstable; urgency=medium

  * Enable tests

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 23 Jan 2023 15:51:22 +0000

ectrans (1.1.0-3) unstable; urgency=medium

  * Add patches from Vagrant Cascadian for reproducibility. Closes: #1029227
	- 0001-src-programs-ectrans.in-Avoid-embedding-the-running-.patch
	- 0002-Pass-BUILD_TIMESTAMP-via-CMakeLists.txt-and-use-in-e.patches

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 Jan 2023 15:45:54 +0000

ectrans (1.1.0-2) unstable; urgency=medium

  * Fix cmake ectrans-targets.cmake paths
  * Enable MPI

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Nov 2022 14:20:39 +0000

ectrans (1.1.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1024552)
    Additional copyrights added

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 19 Nov 2022 12:39:17 +0000

=== debian/control ===
Source: ectrans
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo, 
  dh-sequence-fortran-mod,
  ecbuild (>= 3.3.2),
  gfortran | fortran-compiler,
  chrpath,
  libopenblas-dev [ amd64 arm64 armhf i386 mips64el ppc64el s390x ppc64 ],
  libblas-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  mpi-default-dev,
  libfftw3-dev,
  libopenmpi-dev,
  libfiat-dev,
  fiat-utils
Standards-Version: 4.6.1
Homepage: https://github.com/ecmwf-ifs/trans
Vcs-Browser: https://salsa.debian.org:/science-team/ectrans.git
Vcs-Git: https://salsa.debian.org:/science-team/ectrans.git -b debian/latest

Package: libectrans-0
Section: libs
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Spherical Harmonics Transforms library
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran libraries (trans_sp, trans_dp),
 as well as a C interface to the double-precision version (transi_dp)
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: ectrans-utils
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libectrans-0 (= ${binary:Version}) 
Description: Spherical Harmonics Transforms library - utilities
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran libraries (trans_sp, trans_dp),
 as well as a C interface to the double-precision version (transi_dp)
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libectrans-dev
Section: libdevel
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64
Multi-Arch: same
Recommends: ecbuild
Depends:  ${misc:Depends},
 libectrans-0 (= ${binary:Version}),
 ectrans-utils (= ${binary:Version})
Description: Spherical Harmonics Transforms library - development files
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran libraries (trans_sp, trans_dp),
 as well as a C interface to the double-precision version (transi_dp)
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/pkg-info.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
INSTDIR:=$(CURDIR)/debian/tmp
CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake


FC:=$(shell basename $(shell readlink -f /usr/bin/f95))
FMODDIR:=/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/fortran/$(FC)

DEB_CFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
DEB_CXXFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
DEB_FFLAGS_MAINT_APPEND= -I$(FMODDIR)
include /usr/share/dpkg/buildflags.mk

#
# OMP Doesn't appear to work on these archs
ARCH_NO_OMP:= riscv64 sparc64
ENABLE_OMP:=  $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NO_OMP)),Off,On)

BUILD_FLAGS = \
	-DENABLE_DOCS=On \
	-DENABLE_MKL=Off \
	-DENABLE_MPI=On \
	-DENABLE_FFTW=On \
	-DENABLE_OMP=$(ENABLE_OMP) \
	-DENABLE_FORTRAN=On 

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=ecbuild --builddir=debian/build

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test || true
endif

override_dh_auto_install:
	dh_auto_install
	chrpath -d $(INSTDIR)/usr/bin/ectrans-benchmark*
	chrpath -d $(INSTDIR)/$(LIBDIR)/*.so*
	# Fix broken paths
	sed -i -e 's%$${_IMPORT_PREFIX}/include/ectrans%/usr/include/${DEB_HOST_MULTIARCH}/ectrans%' \
		$(CMAKE_DIR)/ectrans/ectrans-targets.cmake

## ectrans 1.2.0

=== src/trans/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,16 @@
         SOURCES internal/ftinv_ctlad_mod.F90
         FLAGS   "-O0,fp1,omp")
 
+  endif()
+endif()
+
+if(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
+  if( CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 18 AND CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 19 )
+
+    # See https://github.com/ecmwf-ifs/ectrans/issues/17
+    ectrans_add_compile_options(
+        SOURCES algor/butterfly_alg_mod.F90
+        FLAGS   "-check nopointers")
   endif()
 endif()

=== debian/changelog ===
ectrans (1.2.0-2) unstable; urgency=medium

  * Standards-Version: 4.6.2
  * Build-dep on architecture-is-64-bit
  * Update to arch: any rather than specified list
  * Update openblas,lapack deps
  * Build-depend on dh-fortran-mod (>= 0.32)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Jan 2024 18:26:49 +0000

ectrans (1.2.0-1) experimental; urgency=medium

  * Add d/watch file
  * New upstream release
  * Ignore test failures; just log in this release
  * Add bash-completion file

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Jan 2023 15:56:13 +0000

=== debian/control ===
Source: ectrans
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-buildinfo, 
  dh-fortran-mod (>= 0.32),
  ecbuild (>= 3.3.2),
  chrpath,
  libopenblas-dev [ !ia64 !alpha !hurd-amd64 ],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  mpi-default-dev,
  libfftw3-dev,
  libopenmpi-dev,
  libfiat-dev,
  fiat-utils
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf-ifs/trans
Vcs-Browser: https://salsa.debian.org:/science-team/ectrans.git
Vcs-Git: https://salsa.debian.org:/science-team/ectrans.git -b debian/latest

Package: libectrans-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Spherical Harmonics Transforms library
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran 
 libraries (trans_sp, trans_dp), as well as a C interface to the
 double-precision version (transi_dp).
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: ectrans-utils
Architecture: any
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libectrans-0 (= ${binary:Version}) 
Description: Spherical Harmonics Transforms library - utilities
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran 
 libraries (trans_sp, trans_dp), as well as a C interface to 
 the double-precision version (transi_dp).
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libectrans-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: ecbuild, ${fortran:Recommends}
Depends:  ${misc:Depends}, ${fortran:Depends},
 libectrans-0 (= ${binary:Version}),
 ectrans-utils (= ${binary:Version})
Description: Spherical Harmonics Transforms library - development files
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran libraries (trans_sp, trans_dp),
 as well as a C interface to the double-precision version (transi_dp)
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
--- 
+++ 
@@ -1,21 +1,21 @@
 #!/usr/bin/make -f
 
+# export DH_VERBOSE=1
 
 include /usr/share/dpkg/pkg-info.mk
+include /usr/share/dpkg/buildflags.mk
+include /usr/share/debhelper/dh-fortran/fortran-support.mk
+
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
 INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
 INSTDIR:=$(CURDIR)/debian/tmp
 CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake
-
-
-FC:=$(shell basename $(shell readlink -f /usr/bin/f95))
-FMODDIR:=/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/fortran/$(FC)
+FMODDIR:= $(strip $(call get_fmoddir,$(FC_DEFAULT)))
 
 DEB_CFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
 DEB_CXXFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
 DEB_FFLAGS_MAINT_APPEND= -I$(FMODDIR)
-include /usr/share/dpkg/buildflags.mk
 
 #
 # OMP Doesn't appear to work on these archs
@@ -34,7 +34,7 @@
 export OMPI_MCA_rmaps_base_oversubscribe=1
 
 %:
-	dh $@ --buildsystem=ecbuild --builddir=debian/build
+	dh $@ --buildsystem=ecbuild --builddir=debian/build --with fortran_mod
 
 override_dh_auto_configure:
 	dh_auto_configure -- ${BUILD_FLAGS}

## ectrans 1.3.0

=== CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

project( ectrans LANGUAGES C Fortran )
include( ectrans_macros )

ecbuild_enable_fortran( REQUIRED NO_MODULE_DIRECTORY )

### Find (optional) dependencies 

ecbuild_find_package( NAME fiat REQUIRED )

ecbuild_add_option( FEATURE MPI 
                    DESCRIPTION "Support for MPI distributed memory parallelism"
                    CONDITION fiat_HAVE_MPI )

ecbuild_add_option( FEATURE OMP
                    DEFAULT ON
                    DESCRIPTION "Support for OpenMP shared memory parallelism"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS Fortran" )

ecbuild_add_option( FEATURE DOUBLE_PRECISION
                    DEFAULT ON
                    DESCRIPTION "Support for Double Precision" )

ecbuild_add_option( FEATURE SINGLE_PRECISION
                    DEFAULT ON
                    DESCRIPTION "Support for Single Precision" )

if( HAVE_SINGLE_PRECISION )
  set( single "single" )
endif()
set( HAVE_dp ${HAVE_DOUBLE_PRECISION} )
set( HAVE_sp ${HAVE_SINGLE_PRECISION} )

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "Use MKL for BLAS and/or FFTW"
                    DEFAULT ON
                    REQUIRED_PACKAGES "MKL QUIET" )

if( NOT HAVE_MKL )
    option( FFTW_ENABLE_MKL OFF )
endif()

ecbuild_add_option( FEATURE FFTW
                    DEFAULT ON
                    DESCRIPTION "Support for fftw"
                    REQUIRED_PACKAGES "FFTW COMPONENTS double ${single}" )

ecbuild_add_option( FEATURE TRANSI
                    DEFAULT ON
                    DESCRIPTION "Compile TransI C-interface to trans"
                    CONDITION HAVE_DOUBLE_PRECISION )

ectrans_find_lapack()

### Add sources and tests
include( ectrans_compile_options )
add_subdirectory( src )
add_subdirectory( tests )

### Export
if( BUILD_SHARED_LIBS )
  set( PACKAGE_REQUIRES_PRIVATE_DEPENDENCIES 0 )
else()
  set( PACKAGE_REQUIRES_PRIVATE_DEPENDENCIES 1 )
endif()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -61,42 +61,42 @@
         set( t 47 )
         set( grid O48 )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld0
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 0 -v --meminfo
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 0 -v --meminfo --check 100
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --meminfo
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --meminfo --check 100
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --check 100
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_scders
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --scders
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --scders --check 100
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_vordiv
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --check 100
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_vordiv_uvders
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --uvders
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --uvders --check 100
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_flt
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --flt
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --flt --check 1000
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_nproma16
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --nproma 16
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --nproma 16 --check 100
             MPI ${mpi}
             OMP ${omp}
         )
@@ -111,7 +111,7 @@
   ecbuild_debug_var( EC_HAVE_MALLOC_H )
 
 
-  if( EC_HAVE_MALLOC_H AND NOT CMAKE_Fortran_COMPILER_ID MATCHES "Cray" )
+  if( EC_HAVE_MALLOC_H )
     list( APPEND  TEST_DEFINITIONS
       TRANSI_HAVE_MEMORY
     )
@@ -178,4 +178,11 @@
     LIBS      ectrans_test
     ENVIRONMENT TRANS_USE_MPI=0 )
 
+  if( HAVE_TESTS )
+    ecbuild_add_option( FEATURE MEMORY_TESTS DEFAULT ON DESCRIPTION "Enable memory tests" )
+    if( NOT HAVE_MEMORY_TESTS )
+      set_tests_properties( ectrans_test_transi_memory ectrans_test_transi_memory_lonlat PROPERTIES DISABLED ON )
+    endif()
+  endif()
+
 endif()

=== src/programs/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

if( HAVE_TOOLS )

  if( HAVE_DOUBLE_PRECISION )
    set( trans trans_dp )
  else()
    set( trans trans_sp )
  endif()

  ecbuild_warn_var( ECTRANS_TOOLS_RTABLE_PATH )

  file( GLOB ectrans_programs *.F90 )
  foreach( _program IN ITEMS ${ectrans_programs} )
    get_filename_component( _program ${_program} NAME_WE )

    ecbuild_add_executable(TARGET ${_program}
      SOURCES ${_program}.F90
      LIBS ${trans}
      LINKER_LANGUAGE Fortran
      DEFINITIONS ECTRANS_TOOLS_RTABLE_PATH="${ECTRANS_TOOLS_RTABLE_PATH}" )

  endforeach()

endif()

foreach( prec sp dp )
  if( HAVE_${prec} )
    ecbuild_add_executable(TARGET  ectrans-benchmark-${prec}
                           SOURCES ectrans-benchmark.F90
                           LIBS
                             fiat
                             parkind_${prec}
                             trans_${prec}
                          )
  endif()
endforeach()

# ectrans information tool

get_property( langs GLOBAL PROPERTY ENABLED_LANGUAGES )

foreach( lang ${langs} )
  set( EC_${lang}_FLAGS "${CMAKE_${lang}_FLAGS} ${CMAKE_${lang}_FLAGS_${CMAKE_BUILD_TYPE_CAPS}}" )
endforeach()

configure_file( ectrans.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/ectrans @ONLY )

file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/ectrans
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install( FILES
  ${CMAKE_BINARY_DIR}/bin/ectrans
  DESTINATION
  ${INSTALL_BIN_DIR}
  PERMISSIONS
  OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== src/trans/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,9 @@
 # In applying this licence, ECMWF does not waive the privileges and immunities
 # granted to it by virtue of its status as an intergovernmental organisation
 # nor does it submit to any jurisdiction.
+
+# Preprocess module file containing version information
+configure_file( internal/ectrans_version_mod.F90.in internal/ectrans_version_mod.F90 )
 
 ## Apply workarounds for some known compilers
 
@@ -37,6 +40,7 @@
                                 algor/*
                                 internal/*
                                 external/*
+                                ${CMAKE_CURRENT_BINARY_DIR}/internal/ectrans_version_mod.F90
                           QUIET
                         )
 
@@ -44,18 +48,15 @@
   ecbuild_list_exclude_pattern( LIST trans_src REGEX tpm_fftw.F90 )
 endif()
 
-set( HAVE_dp ${HAVE_DOUBLE_PRECISION} )
-set( HAVE_sp ${HAVE_SINGLE_PRECISION} )
-
-foreach( prec sp dp )
+foreach( prec dp sp )
   if( HAVE_${prec} )
 
     ecbuild_add_library(
       TARGET           trans_${prec}
       LINKER_LANGUAGE  Fortran
       SOURCES          ${trans_src}
-      PUBLIC_INCLUDES  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-                       $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/ectrans>
+      PUBLIC_INCLUDES  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/trans/include>
+                       $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/trans/include/ectrans>
                        $<INSTALL_INTERFACE:include/ectrans>
                        $<INSTALL_INTERFACE:include>
       PUBLIC_LIBS      fiat parkind_${prec}
@@ -73,12 +74,15 @@
                         "No guarantees on link order can be made for the final executable.")
           set( FFTW_LINK PUBLIC ) # Attempt anyway to give FFTW precedence
       endif()
+      ecbuild_debug("target_link_libraries( trans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )")
       target_link_libraries( trans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )
       target_include_directories( trans_${prec} PRIVATE ${FFTW_INCLUDE_DIRS} )
       target_compile_definitions( trans_${prec} PRIVATE WITH_FFTW )
     endif()
+    ecbuild_debug("target_link_libraries( trans_${prec} ${LAPACK_LINK} ${LAPACK_${prec}} )")
     target_link_libraries( trans_${prec} ${LAPACK_LINK} ${LAPACK_${prec}} )
     if( HAVE_OMP )
+      ecbuild_debug("target_link_libraries( trans_${prec} PRIVATE OpenMP::OpenMP_Fortran )")
       target_link_libraries( trans_${prec} PRIVATE OpenMP::OpenMP_Fortran )
     endif()

=== src/transi/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

if( NOT ectrans_VERSION_PATCH )
  set( ectrans_VERSION_PATCH 0 )
endif()

configure_file( version.c.in  version.c )

ecbuild_add_library( TARGET transi_dp
  SOURCES             transi_module.F90
                      transi.h
                      transi.c
                      version.h
                      ${CMAKE_CURRENT_BINARY_DIR}/version.c
  HEADER_DESTINATION  include/ectrans
  PUBLIC_INCLUDES     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
                      $<INSTALL_INTERFACE:include>
  PRIVATE_LIBS        trans_dp
  PRIVATE_DEFINITIONS ECTRANS_HAVE_MPI=${ectrans_HAVE_MPI}
)
ectrans_target_fortran_module_directory( TARGET transi_dp
  MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module/trans_dp
)
file( GLOB transi_includes include/ectrans/* )
install(
  FILES        ${transi_includes}
  DESTINATION  include/ectrans
)

=== debian/changelog ===
ectrans (1.3.0-2) unstable; urgency=medium

  * Ship real header files; build shipped broken symlinks. Closes: #1066427

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Mar 2024 16:08:43 +0000

ectrans (1.3.0-1) unstable; urgency=medium

  * New upstream release
  * Drop strip() hack; bug fixed

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 02 Mar 2024 10:20:50 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
   dh-buildinfo, 
-  dh-fortran-mod (>= 0.32),
+  dh-fortran-mod (>= 0.34),
   ecbuild (>= 3.3.2),
   chrpath,
   libopenblas-dev [ !ia64 !alpha !hurd-amd64 ],

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
 INSTDIR:=$(CURDIR)/debian/tmp
 CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake
-FMODDIR:= $(strip $(call get_fmoddir,$(FC_DEFAULT)))
+FMODDIR:= $(call get_fmoddir,$(FC_DEFAULT))
 
 DEB_CFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
 DEB_CXXFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
@@ -51,3 +51,9 @@
 	# Fix broken paths
 	sed -i -e 's%$${_IMPORT_PREFIX}/include/ectrans%/usr/include/${DEB_HOST_MULTIARCH}/ectrans%' \
 		$(CMAKE_DIR)/ectrans/ectrans-targets.cmake	
+	# Don't ship symlinks
+
+override_dh_fixperms:
+	dh_fixperms
+	rm debian/libectrans-dev/$(INCDIR)/ectrans/transi.h debian/libectrans-dev/$(INCDIR)/ectrans/version.h
+	cp src/transi/version.h src/transi/transi.h debian/libectrans-dev/$(INCDIR)/ectrans

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ectrans-$1\.tar\.gz/ \
  https://github.com/ecmwf-ifs/ectrans/tags .*/v?(\d\d?\d?\..+).tar\.gz

## ectrans 1.3.2

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -61,42 +61,42 @@
         set( t 47 )
         set( grid O48 )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld0
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 0 -v --meminfo --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 0 --meminfo --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --meminfo --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --meminfo --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_scders
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --scders --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --scders --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_vordiv
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_vordiv_uvders
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --uvders --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --vordiv --uvders --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_flt
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --flt --check 1000
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --flt --check 1000 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
         ecbuild_add_test( TARGET ectrans_test_benchmark_${prec}_T${t}_${grid}_mpi${mpi}_omp${omp}_nfld10_nlev20_nproma16
-            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --nproma 16 --check 100
+            COMMAND ectrans-benchmark-${prec} ARGS --truncation ${t} --grid ${grid} --niter 2 --nfld 10 --nlev 20 --nproma 16 --check 100 --norms -v
             MPI ${mpi}
             OMP ${omp}
         )
@@ -129,53 +129,63 @@
   ecbuild_add_test( TARGET ectrans_test_transi_program
     SOURCES   transi/transi_test_program.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_timings
     SOURCES   transi/transi_test_timings.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_lonlat
     SOURCES   transi/transi_test_lonlat.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_io
     SOURCES   transi/transi_test_io.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_memory
     SOURCES   transi/transi_test_memory.c
     LIBS      ectrans_test
     CONDITION EC_HAVE_MALLOC_H
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_memory_lonlat
     SOURCES   transi/transi_test_memory_lonlat.c
     LIBS      ectrans_test
     CONDITION EC_HAVE_MALLOC_H
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_vordiv_to_UV
     SOURCES   transi/transi_test_vordiv_to_UV.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_dirtrans_adjoint
     SOURCES   transi/transi_test_dirtrans_adjoint.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_invtrans_adjoint
     SOURCES   transi/transi_test_invtrans_adjoint.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   ecbuild_add_test( TARGET ectrans_test_transi_lonlat_diff_incr
     SOURCES   transi/transi_test_lonlat_diff_incr.c
     LIBS      ectrans_test
+    LINKER_LANGUAGE C
     ENVIRONMENT TRANS_USE_MPI=0 )
 
   if( HAVE_TESTS )

=== src/programs/CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,7 @@
   if( HAVE_${prec} )
     ecbuild_add_executable(TARGET  ectrans-benchmark-${prec}
                            SOURCES ectrans-benchmark.F90
+                           LINKER_LANGUAGE Fortran
                            LIBS
                              fiat
                              parkind_${prec}

=== debian/changelog ===
ectrans (1.3.2-1) unstable; urgency=medium

  * New upstream release
  * Set Debian Science Maint. as maintainer
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 25 Apr 2024 09:27:41 +0100

ectrans (1.3.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 12 Apr 2024 08:48:43 +0100
